"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Flow = (function () {
  function Flow(eventHandlers) {
    _classCallCheck(this, Flow);

    this._eventHandlers = new Map(eventHandlers);
    this._q = [];
    this._running = false;
  }

  _createClass(Flow, [{
    key: "_dispatchEvents",
    value: function _dispatchEvents() {
      if (!this._running) {
        this._running = true;
        try {
          while (this._q.length > 0) {
            this._handleEvent(this._q.shift());
          }
        } finally {
          this._running = false;
        }
      }
    }
  }, {
    key: "dispatch",
    value: function dispatch(event, payload, context) {
      this._q.push({ event: event, payload: payload, context: context });
      this._dispatchEvents();
    }
  }, {
    key: "_handleEvent",
    value: function _handleEvent(item) {
      var eventHandlers = this._eventHandlers.get(item.event);
      if (eventHandlers) {
        eventHandlers.forEach(function (eventHandler) {
          eventHandler(item.context, item.payload);
        });
      }
    }
  }]);

  return Flow;
})();

exports["default"] = Flow;
module.exports = exports["default"];